(* stampa in ordine inverso elementi inseriti da input e memorizzati in una lista *)
Program ListaReverse;

type	lista = ^cella;
	posizione = lista;

	cella = record
		precedente : posizione;
		valore : integer;
		successivo : posizione
	end;

var	L : lista;
	coda : posizione;

Procedure Inserisci();
var 	numero : integer;
	pattivo : posizione;
Begin
	numero := 0;
	pattivo := NIL;
	L := NIL;

	(* continua a chiedere l'inserimento fino a quando non si
		indica un valore negativo *)
	while numero>=0 do
	Begin
		Write('Numero da inserire: ');
		Readln(numero);
		
		if (numero >= 0) then 
		Begin
			(* lista vuota *)
			if L=NIL then
			Begin
				new(pattivo);
				pattivo^.precedente:=NIL;
				pattivo^.valore:=numero;
				pattivo^.successivo:=NIL;
				L:=pattivo
			End else (* lista non vuota *)
			Begin
				new(pattivo^.successivo);
				pattivo^.successivo^.precedente:=pattivo;
				pattivo^.successivo^.valore:=numero;
				pattivo^.successivo^.successivo:=NIL;
				pattivo:=pattivo^.successivo
			End
		End else	coda:=pattivo
	End
End;

(* visita inversa della lista *)
Procedure Visita();

Begin
	while coda<>NIL do
	Begin
		writeln(coda^.valore);
		coda:=coda^.precedente
	End

End;

Begin
	Inserisci();
	Visita()
End.
